import { vitest } from 'vitest';
import { type RouteLocation } from 'vue-router';

import { type MountingOptions, shallowMount } from '@vue/test-utils';
import dayjs from 'dayjs';
import sinon, { type SinonStubbedInstance } from 'sinon';

import ConfermaService from '@/entities/conferma/conferma.service';
import AlertService from '@/shared/alert/alert.service';
import { DATE_TIME_LONG_FORMAT } from '@/shared/composables/date-format';

import NotificaUpdate from './notifica-update.vue';
import NotificaService from './notifica.service';

type NotificaUpdateComponentType = InstanceType<typeof NotificaUpdate>;

let route: Partial<RouteLocation>;
const routerGoMock = vitest.fn();

vitest.mock('vue-router', () => ({
  useRoute: () => route,
  useRouter: () => ({ go: routerGoMock }),
}));

const notificaSample = { id: 123 };

describe('Component Tests', () => {
  let mountOptions: MountingOptions<NotificaUpdateComponentType>['global'];
  let alertService: AlertService;

  describe('Notifica Management Update Component', () => {
    let comp: NotificaUpdateComponentType;
    let notificaServiceStub: SinonStubbedInstance<NotificaService>;

    beforeEach(() => {
      route = {};
      notificaServiceStub = sinon.createStubInstance<NotificaService>(NotificaService);
      notificaServiceStub.retrieve.onFirstCall().resolves(Promise.resolve([]));

      alertService = new AlertService({
        i18n: { t: vitest.fn() } as any,
        toast: {
          show: vitest.fn(),
        } as any,
      });

      mountOptions = {
        stubs: {
          'font-awesome-icon': true,
          'b-input-group': true,
          'b-input-group-prepend': true,
          'b-form-datepicker': true,
          'b-form-input': true,
        },
        provide: {
          alertService,
          notificaService: () => notificaServiceStub,
          confermaService: () =>
            sinon.createStubInstance<ConfermaService>(ConfermaService, {
              retrieve: sinon.stub().resolves({}),
            } as any),
        },
      };
    });

    afterEach(() => {
      vitest.resetAllMocks();
    });

    describe('load', () => {
      beforeEach(() => {
        const wrapper = shallowMount(NotificaUpdate, { global: mountOptions });
        comp = wrapper.vm;
      });
      it('Should convert date from string', () => {
        // GIVEN
        const date = new Date('2019-10-15T11:42:02Z');

        // WHEN
        const convertedDate = comp.convertDateTimeFromServer(date);

        // THEN
        expect(convertedDate).toEqual(dayjs(date).format(DATE_TIME_LONG_FORMAT));
      });

      it('Should not convert date if date is not present', () => {
        expect(comp.convertDateTimeFromServer(null)).toBeNull();
      });
    });

    describe('save', () => {
      it('Should call update service on save for existing entity', async () => {
        // GIVEN
        const wrapper = shallowMount(NotificaUpdate, { global: mountOptions });
        comp = wrapper.vm;
        comp.notifica = notificaSample;
        notificaServiceStub.update.resolves(notificaSample);

        // WHEN
        comp.save();
        await comp.$nextTick();

        // THEN
        expect(notificaServiceStub.update.calledWith(notificaSample)).toBeTruthy();
        expect(comp.isSaving).toEqual(false);
      });

      it('Should call create service on save for new entity', async () => {
        // GIVEN
        const entity = {};
        notificaServiceStub.create.resolves(entity);
        const wrapper = shallowMount(NotificaUpdate, { global: mountOptions });
        comp = wrapper.vm;
        comp.notifica = entity;

        // WHEN
        comp.save();
        await comp.$nextTick();

        // THEN
        expect(notificaServiceStub.create.calledWith(entity)).toBeTruthy();
        expect(comp.isSaving).toEqual(false);
      });
    });

    describe('Before route enter', () => {
      it('Should retrieve data', async () => {
        // GIVEN
        notificaServiceStub.find.resolves(notificaSample);
        notificaServiceStub.retrieve.resolves([notificaSample]);

        // WHEN
        route = {
          params: {
            notificaId: `${notificaSample.id}`,
          },
        };
        const wrapper = shallowMount(NotificaUpdate, { global: mountOptions });
        comp = wrapper.vm;
        await comp.$nextTick();

        // THEN
        expect(comp.notifica).toMatchObject(notificaSample);
      });
    });

    describe('Previous state', () => {
      it('Should go previous state', async () => {
        notificaServiceStub.find.resolves(notificaSample);
        const wrapper = shallowMount(NotificaUpdate, { global: mountOptions });
        comp = wrapper.vm;
        await comp.$nextTick();

        comp.previousState();
        await comp.$nextTick();

        expect(routerGoMock).toHaveBeenCalledWith(-1);
      });
    });
  });
});
